// Последнее обновление 2017-05-31 by Phisik
// Основной файл программы
// После разгрузки тут остались только вспомогательные функции и обработчики прерываний

// Последние изменения 12-11-2019 by AlexDol.
// Скетч HelloDistiller380. SIMPLED_VERSION 0.
// Дисплей I2C_ADDRESS 0x27.
// MQTT_SERIAL_BAUDRATE  250000

#include "configuration.h"
#include "declarations.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Прерывание вызывается 125 раз в секунду
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
ISR(TIMER2_COMPA_vect)
{
  // Сброс таймера
  TCNT2 = 0x00;

  Counter1++;
  if (Counter1 == 62)
  {
    NeedDisplaying = true;
  }
  if (StateVolts == 1) return;

  if (Counter1 % 25 == 0)
  {
    //    Sec5++;
  }
  // Сканируем клавиатуру три раза секунду или если находимся не в режиме отображения информации, то постоянно, то есть 125 раз в секунду
  if (BeepTime > 1) BeepTime--;
  else
  {
    if (BeepTime == 1) analogWrite(PIN_SOUND, 255);
    BeepTime = 0;
  }
  // Следим за защитой от дребезга клавиш
  if (Counter1 % DEBOUNCE_CYCLES == 0)
  {
    if (CountKeys > 0 && flScanKbd == 0) CountKeys--;
    flNeedScanKbd = 1;
  }
  if (Counter1 >= 125)
  {
    if (CountKeys > 0)
    {
      if (secPressKeys > 0) {
        AddPressKeys = 1;
        AddPressKeys10 = 10;
      }
      if (secPressKeys > 3) {
        AddPressKeys = 5;
        AddPressKeys10 = 20;
      }
      if (secPressKeys > 5) {
        AddPressKeys = 10;
        AddPressKeys10 = 50;
      }
      if (secPressKeys > 10) {
        AddPressKeys = 100;
        AddPressKeys10 = 100;
      }
      if (secPressKeys > 15) {
        AddPressKeys = 200;
        AddPressKeys10 = 250;
      }
      if (secPressKeys < 200) secPressKeys++;
    }
    else
    {
      secPressKeys = 0;
      AddPressKeys = 1;
      AddPressKeys10 = 10;
    }
    zPSOut = zPS;
    zPS = 0;
    if (time1 > 0) time1--;
    else time1 = 0;
    if (time2 > 0) time2--;
    else time2 = 0;
    if (time3 > 0) time3--;
    else time3 = 0;

    if (CountState > 0)
    {
      if (CountState == 1) bLCDclearFlag = true;
      CountState--;
    }
    Seconds++;
    Counter1 = 0;
    NeedDisplaying = true;
    flCrossZero++;

    // Если контроллер используется как термостат, или это уже чтение готового результата, или при чтении информации датчиков произошла ошибка то читаем раз в секунду.
    // Или мы сейчас вводим поправки.
    if (IspReg == 102 || StepOut != 0 || FlState == 300 || CntErrDs18)
    {
      flNeedTemp = 1; // Устанавливаем флаг того, что надо читать температуру
    }
    else
    {
      // Иначе запускаем расчет один раз в 5 секунд (чтоб поменьше мограл регулятор мощности).
      if (Seconds % 5 == 0) flNeedTemp = 1;
    }
  }
  // Выполняем процесс.

  if (CountState <= 0 && flScanKbd == 0)
  {
    FlState = 0;
    CountState = 0;
  }
}  // ISR(timer2)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Прерывание управления основным симистором
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
ISR(TIMER5_COMPA_vect)
{
#if USE_ASC712==0
  // Включаем симистор
  if (UstPower > 0 && StateMachine < 100)
  {
    // Подаем питание на ТЭНы
    if (StateMachine < 100) digitalWrite(PIN_TRIAC, HIGH);
    // ждем 20 мкс и выключаем симистор
  }
  delayMicroseconds(20);
  if (TimeOpenTriacFact != 9999)
  {
    digitalWrite(PIN_TRIAC, LOW);
  }
#else
  // Отключаем симистор только если установленная мощность меньше заданной
  if (UstPower < Power) digitalWrite(PIN_TRIAC, LOW);
#endif
}
////////////////////////////////////////////////////////////////////////
//Здесь неиспользуемые таймеры
ISR(TIMER5_COMPB_vect)
{ }
ISR(TIMER5_COMPC_vect)
{ }
/////////////////////////////////////////////////////////////////////////
// Функция вызывается по прерыванию нуля от нуля сети 220 вольт
/////////////////////////////////////////////////////////////////////////
unsigned char CntPeriodPause = 0; // Число полу-периодов паузы

#define KPL_FULL_POWER 65   // Число циклов в течение которых клапана полностью запитаны для надежного включения
// time_full_power = KPL_FULL_POWER / 125 секунд

void zero_cross_int()  // function to be fired at the zero crossing to dim the light
{
  unsigned char i;
  unsigned char flOpenClose;
  zPS++;
  flCrossZero = 0;

  TicZero = (int) TCNT5L | (int) (TCNT5H << 8); // Расчитывааем текущее значение таймера
  // Сбрасываем 5-й таймер.
  TCNT5H = 0x00;
  TCNT5L = 0x00;
  if (StateVolts == 1 ) {
    // Если за полу-период не выбрано допустимое количество значений, тогда пропускаем эти выборки и пытаемся выбрать следующий полу-период.
    // также пропускаем выборку если в предыдущий период симистор был отключен

    if (index_input - prev_index_input > MAX_INDEX_BY_PERIOD || index_input - prev_index_input < MIN_INDEX_BY_PERIOD)
    {
      index_input = prev_index_input;
      SqNaprT = SqNaprPrevT;
    }
    else
      CntPeriod++; // Если число в выборке допустимо, то прибавляем счетчик полу-периодов выборки

    // Если считали достаточное количество полу-периодов, тогда расчет закончен.
    if (CntPeriod >= CNT_PERIOD)
    {
      if (flCorrASC712 == 0) indexOut = index_input;
      StateVolts = 2; // Если был расчет тока (напряжения), то ставим признак его окончания
      CntPeriodPause = 0;
    }
  }
  else
    CntPeriodPause++;

  if (StateVolts == 4) {
    // Если пропустили два по необходимому числу полу-периодов, запускаем расчет.
    // Еще одно условие, чтобы мы не находились в режиме ввода клавиш, тогда расчет не запускаем, чтобы не тормозить отчаянно
    // при вводе информации
    if (CntPeriodPause > CNT_PERIOD && CountKeys == 0) {
      StateVolts = 0;
      if (CorrectASC712)
        flCorrASC712 = !flCorrASC712; // Читаем через раз, то мощность, то напряжение если, конечно установлено что надо считать мощность.
    }
  }
  if (StateVolts == 0) {
    index_input = 0;
    StateVolts = 1;
    TCNT4H = 0x00;
    TCNT4L = 0x00;
    CntPeriod = 0;
    SqNaprT = 0;
  }
  prev_index_input = index_input;
  SqNaprPrevT = SqNaprT;

#if USE_ASC712==0
  if (UstPower >= Power) {
    // Если мощность больше или равна номинальной, включаем триак всегда, при этом прерывание на закрытие никогда не выполнится.
    TimeOpenTriac = 9999;
    TimeOpenTriacFact = 9999;
    // подаем питание на ТЭНы
    if (StateMachine < 100)
      digitalWrite(PIN_TRIAC, HIGH);
  } else
    TimeOpenTriacFact = TimeOpenTriac;
  // Если мощность не установлена отключена, или состояние машины конечное, то на всякий случай отключаем
  if (UstPower <= 0 || StateMachine >= 100)
    digitalWrite(PIN_TRIAC, LOW);

  if (TimeOpenTriac <= 10) {
    // подаем питание на ТЭНы
    if (StateMachine < 100 && UstPower > 0) digitalWrite(PIN_TRIAC, HIGH);
    TimeOpenTriacFact = 9999;
  }
  // В прерывании нуля настраиваем, чтобы прерывание на 5-м таймере выдалось через то время, которое мы ранее рассчитали.
  OCR5AH = (char)(TimeOpenTriacFact >> 8);
  OCR5AL = (char) TimeOpenTriacFact;

  // Если считаем ток(напряжение), тогда
#else  //  #if USE_ASC712==0
  // Устанавливаем закрытие симистора по прерыванию таймера через некоторое время (отступить от таблицы мощности на 2 шага вполе достаточно).
  TimeOpenTriacFact = tableS10[MAX_TABLE_T - 2];
  TimeOpenTriacFact *= 10;
  TimeOpenTriac = TimeOpenTriacFact;
  OCR5AH = (char)(TimeOpenTriacFact >> 8);
  OCR5AL = (char)TimeOpenTriacFact;

  // Если мощность установлена, то запускаем измерительный период
  if (UstPower > 0 || UstPower >= Power)
    digitalWrite(PIN_TRIAC, HIGH);
  else if (UstPower <= 0)
    digitalWrite(PIN_TRIAC, LOW);   // Если мощность не установлена, то на реле подаюм нулевой сигнал

#endif //  #if USE_ASC712==0
}  // zero_сross_int()

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Функция расчета квадратного корня
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Значения корней от 0 до 90 и от 256 до 512 считаются по очень приблизительным формулам, поскольку такое значение среднеквадратичного в нормальной сети 220 вольт недопустимо
// Больше 512 значение не определено.
float my_sqrt(unsigned long tsQT)
{
  return sqrt(tsQT);
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Разные вспомогательные функции
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Функция устанавливает пищалку на заданное время (в 1/125 секунды), то есть 125-это одна секунда.
void my_beep(unsigned int mBeepTime)
{
  analogWrite(PIN_SOUND, 10);
  BeepTime = mBeepTime;
}
// Процедура осуществляет ПИД регулирование температуры.
// В качестве результата возвращается коэффициент мощности, умноженный на 1000, то есть
// 1000 - это 100% подача мощности на ТЭНы.
void ProcessPIDTemp(int NeedTemp, int FactTemp)
{
  NewErrTemp = (NeedTemp - FactTemp);
  DtTemp = NewErrTemp - OldErrTemp;
  ItTemp = ItTemp + NewErrTemp;

  if (ItTemp < -1000) ItTemp = -1000;
  else if (ItTemp > 1000) ItTemp = 1000;

  OldErrTempOut = OldErrTemp; // Запоминаем старую ошибку.
  OldErrTemp = NewErrTemp; // Запоминаем старую ошибку.
  // Считаем коэффициент температуры
  KtT = ((long)PIDTemp[0] * NewErrTemp * 8 + (long)PIDTemp[1] * ItTemp / 10 + (long)PIDTemp[2] * DtTemp * 10) / 10;

  if (KtT > 1000) KtT = 1000;
  if (KtT < 0) KtT = 0;
  // Если значение температуры превысило нужную, то сбрасываем интегральный коэффицциент
  // и убираем мощность.
  if (FactTemp >= NeedTemp) {
    ItTemp = 0 ;
    KtT = 0;
  }
}
void ProcessPIDPress(int NeedTemp, int FactTemp)
{
  NewErrTemp = (NeedTemp - FactTemp);
  DtTemp = NewErrTemp - OldErrTemp;
  ItTemp = ItTemp + NewErrTemp;

  if (ItTemp < -1000) ItTemp = -1000;
  else if (ItTemp > 1000) ItTemp = 1000;

  OldErrTempOut = OldErrTemp; // Запоминаем старую ошибку.
  OldErrTemp = NewErrTemp; // Запоминаем старую ошибку.
  // Считаем коэффициент температуры
  KtT = ((long)PIDTemp[0] * NewErrTemp * 8 + (long)PIDTemp[1] * ItTemp / 10 + (long)PIDTemp[2] * DtTemp * 10) / 10;
  if (KtT > 1000) KtT = 1000;
  if (KtT < 0) KtT = 0;
  // Если значение температуры превысило нужную, то сбрасываем интегральный коэффицциент
  // и убираем мощность.
}
void ScanDS18b20Slave()
{
  char maxDs;
  maxDs = 0;
  // Первый этап-читаем датчики три раза.
  while (nPopr < 3)
  {
    nPopr++;
    delay(1500);
    ds1820_devices = 0;
    while (ds.search(ds1820_rom_codes[ds1820_devices])) {
      ds1820_devices++;
      if (ds1820_devices >= MAX_DS1820) break;
    }
    ds.reset_search();
    if (ds1820_devices > maxDs) maxDs = ds1820_devices;
    if (ds1820_devices >= 3) return;
  }
  // Если за время чтения количество датчиков больше 1,то читаем датчики еще 7 раз
  if (maxDs > 0)
  {
    while (nPopr < 10)
    {
      nPopr++;
      delay(1500);
      ds1820_devices = 0;
      while (ds.search(ds1820_rom_codes[ds1820_devices])) {
        ds1820_devices++;
        if (ds1820_devices >= MAX_DS1820) break;
      }
      ds.reset_search();
      if (ds1820_devices > maxDs) maxDs = ds1820_devices;
      if (ds1820_devices >= 3) return;
    }
  }
}
#ifdef TESTMEM
int freeRam ()
{
  extern int __heap_start, *__brkval;
  int v;
  return (int) &v - (__brkval == 0 ? (int) &__heap_start : (int) __brkval);
}
#endif
