// Последнее обновление 2018-07-25 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам
// Основной цикл программы

#include "configuration.h"
#include "declarations.h"


char my_tx_buffer[MY_TX_BUFFER_SIZE];
char my_rx_buffer[MY_RX_BUFFER_SIZE];

void GetStateSerial()
{
  sprintf_P(my_tx_buffer, PSTR("%lu\tT=\t%3u\t%3u\t%3u\tS=%3u\t%4uW\tOFF=%1i\t%3uV"), Seconds, temps[TEMP_KUB], temps[TEMP_DEFL], temps[TEMP_TSA], IspReg, StateMachine, UstPower, (int) flAllOff, MaxVoltsOut);
  DEBUG_SERIAL.println(my_tx_buffer);
}

void GetStateSerialErr()
{
  sprintf_P(my_tx_buffer, PSTR("Err ds18b20 CntDs=%3u NumDs=%3u"), CntErrDs18, NumErrDs18);
  DEBUG_SERIAL.println(my_tx_buffer);
}

void loop()
{
  int i, j;
  char k;
  unsigned long SqNapr = 0, SqNaprPrev = 0, FindPower;
  byte data[12];
  byte present = 0;
  unsigned int raw;
  int raw1;
  byte ds18b20CRC;
  //  static char  FlFindPower;
  char flErrDs18;
  //unsigned int tic;

  if (bLCDclearFlag) {
    lcd.clear();
    bLCDclearFlag = false;
  }
  //  static int PowerPrev=0;
  //  static int UstPowerPrev=0;
  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  // print the number of seconds since reset:
  // Если есть необходимость произвести отображениеш  информации на дисплее и среднеквадратичное уже рассчитано.
  // И контроллен находится в режиме "лазанья" по меню, тогда отображаем информацию.
  // Или контроллер не находится в режиме ошибки.

#if USE_MQTT_BROKER
  // Обмен данными с ESP для работы с протоколом MQTT
  handleMqttSerial();
#endif  // USE_MQTT_BROKER


  // Для обеспечения равномерности выборки делаем это в цикле подряд.
  while (StateVolts == 1)
  {

#if USE_ASC712==0
    // если датчик тока не используем, тогда читаем значение и делим его на два
    if (!flCorrASC712)  {
      // читаем показания с pin А3 и делим их на два, для увеличения
      // измеряемого выходного напряжения.
      resultU = (analogRead(PIN_READU) >> 1);
    } else {
      if (StateVolts == 1)
      {
        if (CorrectASC712 == 3)
        {
          resultU = analogRead(PIN_READI) - 512; // читаем показания с датчика тока.
          if (resultU < 0) resultU = -resultU;
        }
        else
        {
          resultU = analogRead(PIN_READI) - 512; // читаем показания с датчика тока.
          if (resultU < 0) resultU = -resultU;
        }
      }
    }

#else
    // Если используем датчик тока, тогда читаем значение, если оно больше 512, значит приводим его к 512;
    resultU = analogRead(PIN_READI) - 512; // читаем показания с датчика тока.
    if (resultU < 0) resultU = -resultU;
#endif

    //      data_adc[index_input]=resultU;
    // Пробуем расчет квадратов на лету.
    SqNaprT = SqNaprT + (unsigned long) resultU * (unsigned long) resultU;

    if (index_input < MAX_INDEX_INPUT) index_input++;
    else StateVolts = 0; // Если превышер размер массива, ставим флаг расчета заново.

  }

  if (NeedDisplaying && (StateVolts != 1 || IspReg >= 220) && FlState == 0)
  {
    DisplayData();
  }

  // Сканируем клавиатуру, если установлен флаг.
  if (flNeedScanKbd == 1 )
  {
    ScanKbd();
    flNeedScanKbd = 0;
  }

  if (flNeedTemp == 1 && IspReg >= 220)
  {
    flNeedAnalyse = 1;
  }

  if (StateVolts != 1)
  {
    if (flNeedTemp == 1)
    {
      if (StepOut == 0)
      {
        ds.reset();
        ds.write(0xCC, 1);        // start conversion, with parasite power on at the end
        ds.write(0x44, 1);        // start conversion, with parasite power on at the end
        flNeedTemp = 0;
        for (j = 0; j < ds1820_devices; j++) ds1820_flread[j] = 0;
        StepOut = 1;
      }
      else
      {
        flErrDs18 = 0; // Сбрасываем флаг nошибки датчика ds18b20
        for (j = 0; j < ds1820_devices; j++)
        {
          // По каждому датчику температуру считаем три раза
          k = 0;
          while (k < 3)
          {
            if (ds1820_flread[j] == 0)
            {
              present = ds.reset();

#ifdef TIMING
              TCNT4H = 0x00;
              TCNT4L = 0x00;
#endif
              // Здесь вообще засада, передача кода датчика занимает около 1600 тиков таймера, что гарантирует пропуск регуляции как минимум одного полупериода.
              // Возможно решение - посадить каждый датчик на отдельный ПИН, тогда код датчика передавать не нужно.
              // Phisik: просто нужно делать все асинхронно, а не ждать пока рак на горе свистнет. Послали в шину флаг чтения. На следующем loop-e считали значение(я)

              ds.select(ds1820_rom_codes[j]);
#ifdef TIMING
              unsigned int Tic2 = (int) TCNT4L | (int) (TCNT4H << 8); // Расчитывааем текущее значение таймера
              sprintf_P(my_tx_buffer, PSTR("TicDs18Select=%i"), Tic2);
              FlUsart = 1;
#endif
              ds.write(0xBE);         // Read Scratchpad
              for ( i = 0; i < 9; i++)
              {
                data[i] = ds.read();
              }
              ds18b20CRC = OneWire::crc8(data, 8);

              if (ds18b20CRC != data[8]) //  Ошибка чтения, записываем признак ошибки
              {
#ifndef DEBUG
                if (!flErrDs18 && k == 2) // Если ранее в этом сеансе не было ошибок чтения датчика, то прибавляем количество ошибок чтения на единицу
                {
                  flErrDs18 = 1;
                  CntErrDs18++;
                  NumErrDs18 = j + 1; // Запоминаем номер сглючившего датчика.
                  if (CntErrDs18 > 30) DispDopInfo = 4; // Устанавливаем признак вывода информации об ошибке если ошибок больше 4
                  if (FlToUSART) GetStateSerialErr();
                }
#endif
              }
              else // Если контрольная сумма совпадает, то считаем, что все нормально.
              {
                raw = (data[1] << 8) | data[0];
                if (raw & 0x8000)                         // Если там единица - число отрицательное и его надо преобразовать
                { // Стандартное преобразование отрицательного числа, которое в микроконтроллере в дополнительной кодировке
                  raw = (raw ^ 0xffff) + 1;            // Путем исключающего ИЛИ плюс единица
                  raw1 = raw * 5 / 8;
                  raw1 = -raw;
                }
                else
                  raw1 = raw * 5 / 8;
                // Температуру равной 850 считаем ошибочной.
                if (raw1 == 850 || raw1 > 1200)
                {
                  // Если температура скаканула больше чем на 10 градусов, то считаем ошибкой.
                  if (abs(raw1 - temps[j]) > 100 && temps[j] != 0 || raw1 > 1200)
                  {
                    if (!flErrDs18 && k == 2) // Если ранее в этом сеансе не было ошибок чтения датчика, то прибавляем количество ошибок чтения на единицу
                    {
                      flErrDs18 = 1;
                      CntErrDs18++;
                      NumErrDs18 = j + 1; // Запоминаем номер сглючившего датчика.
                      if (CntErrDs18 > 30) DispDopInfo = 4; // Устанавливаем признак вывода информации об ошибке если ошибок больше 4
                      if (FlToUSART) GetStateSerialErr();
                    }
                  }
                }
                else
               {
#ifndef DEBUG
                  // Если температуру считали успешно, то поставим соотв флаг.
                  ds1820_flread[j] = 1;
                  k = 3; // Выходим из цикла чтения
                  temps[j] = raw1;
                  // Если мы сейчас не находимся в режиме ввода поправок к датчикам, то прибавляем к температуре значение поправки

                  if (FlState != 300)
                  {
                    temps[j] = temps[j] + (int) ds1820_popr[j];
                  }
                  // Запоминаем максимальную температуру датчиков
                  if (Maxtemps[j] < temps[j]) Maxtemps[j] = temps[j];
#endif
                }
              }
            }
            k++;
          }
        }

        StepOut = 0;
        flNeedTemp = 0;

        if (!flErrDs18) // Если не было ошибок, то сбрасываем счетчики.
        {
          flNeedAnalyse = 1; // Все необходимые данные прочитаны устанавливаем флаг того, что нужно анализировать состояние выполнения процесса.
          CntErrDs18 = 0;
          NumErrDs18 = 0;
          // Сбрасываем признак вывода информации об ошибке
          if (DispDopInfo == 4) DispDopInfo = 0;
        }
        else
        {
          // Если были ошибки, заново запускаем определение температуры
          ds.reset();
          ds.write(0xCC, 1);        // start conversion, with parasite power on at the end
          ds.write(0x44, 1);        // start conversion, with parasite power on at the end
          flNeedTemp = 0;
          StepOut = 1;
        }
      }
    }
  }

  if (CntErrDs18 > MAX_ERR_DS18)
  {
    flNeedAnalyse = 1;
#ifndef TEST
    IspReg = 217;    // Переводим контроллер в режим ошибки датчиков.
#endif
  }

  if (flNeedAnalyse == 1)
  {
    switch (IspReg)
    {
      case 102: //Текущее состояние - термостат
        //UstPower=0;
        ProcessTermostat();
        break;
      case 103: //Текущее состояние - регулятор мощности
        if (StateMachine < 100) UstPower = UstPowerReg;
        else UstPower = 0;
         // Если стоит признак авто-детектирования ТЭНа, то мощность устанавливаем максимально возможную.
        if (flAutoDetectPowerTEN == 1 && StateMachine < 100) UstPower = 9999;
        break;
      case 104: //Текущее состояние - первый недробный перегон
      case 105: //Текущее состояние - второй дробный
      case 106: //Текущее состояние - третий дробный
        ProcessSimpleDistill();
        break;
#ifndef TEST
        my_beep(BEEP_LONG * 5);
#endif
        digitalWrite(PIN_TRIAC, LOW);
        digitalWrite(PIN_ALL_OFF, ALL_OFF_HIGH);
        flAllOff = 1;
        break;
    }

    if (FlToUSART) GetStateSerial();

    flNeedAnalyse = 0;
  }

  //  анализ отладки
  if (FlUsart == 1)
  {
    // Признак того, что надо выдать информацию в ком-порт (есл ее вдруг невозможно сразу выдать, например, из прерывания).
    DEBUG_SERIAL.println(my_tx_buffer);
    FlUsart = 0;
  }

  // Начало расчета среднеквадратичного

  if (StateVolts == 2)
  {

    StateVolts = 3;

    // поскольку тут идет преобразование и умножение 32 разрядных чисел, делаем это по необходимости, а не каждый раз (хотя какая разница, тут и таких умножений дохрена)
    SqNapr = (long) 220 * 220 * 20 / Power; // Рассчитали сопротивление ТЭНа, умноженное на 20
    R_TEN20 =  SqNapr;

    SqNapr = 0;
    SqNaprPrev = 0;
    //   MaxVolts=0;

#ifdef TESTRM
    TCNT4H = 0x00;
    TCNT4L = 0x00;
#endif

#if USE_ASC712==0
    if (!flCorrASC712) // Расчет напряжения
    {
      TekPower = SqNaprT / index_input; // Определили квадрат напряжения
      // Но фактически мощность подаваемая на ТЭНы меньше из-за падения на симисторе.
      MaxVoltsOut = my_sqrt(TekPower); // Рассчитываем среднеквадратичное

      TekPower = (TekPower * 20) / R_TEN20; // Определили фактическую мощность в зависимости от сопротивления ТЭНа

      if (FactPower > 15 && CorrectASC712 >= 2 && !(UstPower >= Power)) // Если фактическая мощность рассчитана и мы не находимся в режиме подачи полного напряжения на ТЭНы
      {
        // Ошибку рассогласования учитвыаем, если она не более 1/8 мощности ТЭНа.
        NewErr = ((long)UstPower - (long)FactPower) * 200 / (long)Power;
        if (NewErr < -30) NewErr = -30;
        else if (NewErr > 30) NewErr = 30;

        Dt = NewErr - OldErr;
        It = It + NewErr;
        // Накопленную ошибку не более 1/2 мощности ТЭНа.
        if (It < -100) It = -100;
        else if (It > 100) It = 100;

        OldErrOut = OldErr; // Старая ошибка для отображения на экране
        OldErr = NewErr; // Запоминаем старую ошибку.
      }
      else
      {
        // Если мощность не рассчитана, то считаем, что находимся в режиме отладки и не подключили ТЭНы В этом случае просто делаем фазовое регулирование исходя из
        // входного напряжения, не учитывая фактическую мощность, рассчитанную исходя из датчика тока на ТЭНах
        NewErr = 0;
        OldErr = 0;
        OldErrOut = 0;
        It = 0;
        Dt = 0;
      }

      // Пока без коэффиццииенов
      FindKt = (long)(UstPower) * 200 / TekPower;   // Установили коэффициент поиска мощности для регулятора мощности как соотношение необходимой мощности к имеющейся в данный момент.
      FindKt = FindKt + It;                          // Прибавляем коэффициент.

      if (FindKt > 200 || It == -100)
      {
        CntErrPower++;
        if (UstPower < Power && UstPower > 15 && CntErrPower > 100)
        {
          if (FindKt > 200)  {
            DispDopInfo = 3;
            FindKt = 200;
          } // Выводим на экран информацию о низком напряжении но только в том случае, когда не в режиме разгона и установленная мощность больше 15
          else DispDopInfo = 0;            // и в том случае когда не установлено, что не нужно выводить предупреждение о низком уровне напряжения

#endif
        }
      }
      else
      {
        CntErrPower = 0;

        if (DispDopInfo == 3 || DispDopInfo == 4)
        {
          DispDopInfo = 0; // Убираем информацию о низком напряжении, если она была ранее установлена
        }

      }
      if (FindKt < 1) FindKt = 1;
      if (FindKt > 200) FindKt = 200;

      // Поскольку таблица разбита по мощности равномерно в пределах 5/1000 доли, то нет необходимости высчитывать и искать по таблице, достаточно просто поделить.
      TimeOpenTriac = tableS10[FindKt - 1];
      TimeOpenTriac *= 10;

      if (flAutoDetectPowerTEN) TimeOpenTriac = 9999;
    }
    else // Это расчет фактического тока и фактической мощности
    {

      if (CorrectASC712 == 3) // Расчет по напряжениию
      {
        TekPower = SqNaprT / index_input; // Определили квадрат напряжения
        MaxIOut = my_sqrt(TekPower); // Рассчитываем среднеквадратичное
        FactPower = (TekPower * 20) / R_TEN20; // Определили фактическую мощность в зависимости от сопротивления ТЭНа

      }
      else
      {
        // Здесь определили квадрат тока умноженный на 10.
        SqNaprPrev = SqNaprT * 100 / ((unsigned long) index_input * SENSITIVE_ASC712);
        // Определили ток, умноженный на 10 (для вывода на экран).
        MaxIOut = my_sqrt((long)SqNaprPrev * 100 / SENSITIVE_ASC712);
        if (flAutoDetectPowerTEN)
        {
          FindPower = (long) SqNaprPrev * 100 / (SENSITIVE_ASC712);
          TekPower = (unsigned long) 4840 * my_sqrt(FindPower) / MaxVoltsOut; // 4840=220*22
          if (TekPower != 0)
          {
            Power = (int)(TekPower / 10) * 10;
            Power = Power;
          }
        }

        FindPower = (long) SqNaprPrev * R_TEN20 / (20 * SENSITIVE_ASC712);
        FactPower = FindPower;

      }
    }

    //   Сумму квадратов измерений определили, она хранится в переменной SqNapr.
    //   Теперь надо перевести это в фактический ток.
#if USE_ASC712==1

    // Рассчитали сумму, пересчитанную в фактические значения тока.
    SqNaprPrev = SqNaprT * 100 / ( (unsigned long) index_input * SENSITIVE_ASC712);

    FindPower = (long) SqNaprPrev * R_TEN20 / (20 * SENSITIVE_ASC712);
    FactPower = FindPower;

    MaxVoltsOut = my_sqrt(FindPower * R_TEN20 / 20);

    if (UstPower < Power) DispDopInfo = 3; // Выводим на экран информацию о низком напряжении если находимся не в режиме разгона.

    else if (DispDopInfo == 3) DispDopInfo = 0; // Убираем информацию о низком напряжении, если она была ранее установлена
#endif

    StateVolts = 4;
  }

}
