// Последнее обновление 2017-05-31 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам
// Здесь будут программы для всех процессов

#include "configuration.h"
#include "declarations.h"

void PrepareProcess()
{
  char i;
  // Максимальную температуру процессов зануляем.
  for (i = 0; i < MAX_DS1820; i++)
  {
    Maxtemps[i] = 0;
  }
  // Все таймеры зануляем.
  time1 = 0;
  time2 = 0;
  time3 = 0;
  flAutoDetectPowerTEN = 0;// Убираем признак авто-детектирования ТЭНОв
}

void ProcessTermostat()
{
  if (ds1820_devices == 0) StateMachine = 100;

  switch (StateMachine)
  {
    case 0: // Процесс не запущен
    // Процесс термостат запускается автоматически, чтобы он работал даже если выключат и включат свет.
    break;
    case 1: // Старт процесса

      StateMachine = 2;
    case 2: // Основной цикл программы, пытаемся регулировать мощность, не превышая температуру
      if (temps[TEMP_TERMOSTAT] <= TempTerm)
      {
        ProcessPIDTemp(TempTerm, temps[TEMP_TERMOSTAT]);
        UstPower = (long)Power * KtT / 1000;

        // Мощность ограничена установленной мощностью термостата
        if (UstPower > PowerTermostat) UstPower = PowerTermostat;

        break;
      }
      // Температура все-таки стала выше нужной - идем к следующему этапу
      StateMachine = 3;
    // if (BeepStateProcess) my_beep(BEEP_LONG);

    case 3: //
      UstPower = 0; // Убираем мощность с ТЭНов
      if (temps[TEMP_TERMOSTAT] > TempTerm - Delta)
      {
        break;
      }
      // Если температура упала ниже TempTerm-Delta, идем регулировать ТЭНы
      StateMachine = 2;
      // if (BeepStateProcess) my_beep(BEEP_LONG);
      break;
    case 100:// Конечное состояние автомата
      digitalWrite(PIN_ALL_OFF, ALL_OFF_HIGH);
      flAllOff = 1;
      UstPower = 0; // Убираем мощность с ТЭНов
      break;
  }
}
void ProcessSimpleDistill()
{

  if (StateMachine >= 4)
  { // Переводим автомат в стадию завершения 
    StateMachine = 4;
    if (BeepStateProcess) my_beep(BEEP_LONG);
  }

  // Проверяем температуру в ТСА
  if (temps[TEMP_TSA] >= MAX_TEMP_TSA)
  {
    StateMachine = 101; // Переводим автомат в состояние аварии по ТСА.
    UstPower = 0;
  }
  switch (StateMachine)
  {
  case 0: // Процесс не запущен
    break;
  case 1: // Начало процесса
    PrepareProcess();
    StateMachine = 2;
    if (BeepStateProcess) my_beep(BEEP_LONG);
    digitalWrite(PIN_ALL_OFF, !ALL_OFF_HIGH);
    flAllOff = 0;

  case 2: // Ожидание, пока прогреется термометр в дефлегматоре

    UstPower = Power; // Устанавливаем максимальную мощность для разгона
    // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
    // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
    if (temps[TEMP_DEFL] < TempDeflBegDistil && ds1820_devices>1 || (TempDeflBegDistil < 0 && temps[TEMP_KUB] < -TempDeflBegDistil)) break;
    StateMachine = 3;
    if (BeepStateProcess) my_beep(BEEP_LONG);

  case 3:// Ждем, пока температура в кубе не превысит установленную
    UstPower = PowerDistil; // Устанавливаем максимальную мощность для разгона
    if (IspReg == 104) TekTemp = Temp1P; //Текущее состояние - первый недробный перегон
    if (IspReg == 105) TekTemp = Temp2P; //Текущее состояние - второй дробный 
    if (IspReg == 106) TekTemp = Temp3P; //Текущее состояние - третий дробный

    if (temps[TEMP_KUB] >= TekTemp)
    {
      StateMachine = 4;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    else
      break;
  case 4:// 
    UstPower = 0;
    SecondsEnd = 0;
    if (SecondsEnd <= 0)
    {
      // Переводим автомат в конечное состояние
      StateMachine = 100;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    break;
  case 101: // Превышение температуры в ТСА!!!
    my_beep(3 * BEEP_LONG);
  case 100:// Конечное состояние автомата
    // Отключаем на всякий случай все!
    if (BeepEndProcess) my_beep(BEEP_LONG);
    UstPower = 0;
    digitalWrite(PIN_ALL_OFF, ALL_OFF_HIGH);
    flAllOff = 1;
    break;
  }
}
