// Последнее обновление 2018-08-10 by Phisik
// Здесь будут все переменные
// Был соблазн оставить их в основном файле, но так легче навести порядок

#include "configuration.h"
#include "declarations.h"

const char     my_version[] = "v3.80_Dist";

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Связь с внешним миром
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
char  FlToUSART = 0;    // Признак того, что CОМ-порт используется для вывода информации
char           cmdGPRS = ' ';      // Посланная команда от сервера
char           cmdGPRSIsp = ' ';   // Выполненная команда от сервера
char pos_rx_buffer = 0;
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Настройка регулятора мощности
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
char flCorrASC712  = 0;     // Флаг того, что надо расчитывать в данный момент среднеквадратичную мощность 1-мощность, 2-напряжение.
char CorrectASC712 = 2;     // Признак того, как надо использовать датчик asc712
// (0- не надо, 1 - только показывать мощность, 2-корректировать мощность через фактический ток, 3- ПИД регулирование через ток)

char flAutoDetectPowerTEN = 0;
int  FindKt = 0;          // Нужный процент открытия симистора
char CntPeriod = 0;       //Номер обсчитываемого полу-периода

unsigned char zPS = 0;    // Число прерываний нуля за секунду.
unsigned char zPSOut = 0; // Число прерываний нуля за секунду для вывода на экран.

// Расчет мощности
#define MAX_TABLE_T 200
unsigned char tableS10[MAX_TABLE_T]; //табличное значение времени задежки открытия триака
unsigned long SqNaprT = 0, SqNaprPrevT = 0; //  Переменные для накапливания квадратов напряжений.

int NewErr;		// Новая ошибка рассогласования
int OldErrOut;	// Новая ошибка рассогласования
int OldErr;		// Старая ошибка рассогласования
int It;			// Интегральная составляющая (без коэффициентов, чтобы избавиться от дробей, коэффициенты учтем в момент ее применения);
int Dt;			// Дифференциальная составляющая (без коэффициентов, чтобы избавиться от дробей, коэффициенты учтем в момент ее применения);

int NewErrTemp;	// Новая ошибка рассогласования температуры
int OldErrTemp;	// Старая ошибка рассогласования температуры
int OldErrTempOut;	// Старая ошибка рассогласования температуры
int ItTemp;     // Интегральная составляющая температуры (без коэффициентов, чтобы избавиться от дробей, коэффициенты учтем в момент ее применения);
int DtTemp;     // Дифференциальная составляющая температуры (без коэффициентов, чтобы избавиться от дробей, коэффициенты учтем в момент ее применения);
int KtT;        // Коэффициент мощности ТЭНа в 1000 долей.

char PIDTemp[3] = {
  20, 10, 30
};    // Пропорциональный коэффициент пид-регулятора температуры [0]
// Интегральный коэффициент пид-регулятора температуры [1]
// Дифференциальный коэффициент пид-регулятора температуры [2]
unsigned char PIDTime = 5;
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Настройка таймеров и периодов
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int time1 = 0; // Таймер для отсчета секунд 1
int time2 = 0; // Таймер для отсчета секунд 2
int time3 = 0; // Таймер для отсчета секунд 3
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Настройка датчиков температуры
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
OneWire         ds(PIN_DS18B20);  // on pin 37
uint8_t   ds1820_devices;                  // Количество датчиков ds18b20
uint8_t   ds1820_rom_codes[MAX_DS1820][9]; // Коды датчиков ds18b20
char            ds1820_popr[MAX_DS1820];                  // Поправки к температуре датчиков
char            ds1820_flread[MAX_DS1820];                  // Поправки к температуре датчиков
unsigned char   CntErrDs18 = 0; // Количество глюков, зафиксированных от датчика
char            CntErrPower = 0; // Количество глюков, зафиксированных от датчика
char            NumErrDs18 = 0; // Номер сглючившего датчика
int             TekTemp = 0; //Текущая температура для отображения
int             temps[MAX_DS1820];            // Температура датчиков
int             Maxtemps[MAX_DS1820];           // максимальная Температура датчиков  за процесс.
unsigned char   nPopr = 0;                   // Текущий датчик, которому вносится поправка

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Настройки программ
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int    FlState = 0; // Флаг состояния конечного автомата обработки нажатия кнопок клавиатуры
unsigned char IspReg = 101; // Используемый в данный момент режим (по умолчанию пока ставим Monitoring)
char  DispPage = 0; // Какую страницу отображать на дисплее
int   TempTerm = 650;
int   Delta = 20;

char  BeepEndProcess = 1;   // Пищать динамиком по окончании процесса.
char  BeepStateProcess = 2; // Пищать динамиком при переходе между процессами.
char  BeepKeyPress = 1;     // Пищать динамиком при нажатии на клавиши
int   Temp1P = 970;      // Температура первой (недробной) перегонки
int   Temp2P = 950;      // Температура второй  перегонки  (дистилляция без дефлегматора)
int   Temp3P = 940;      // Температура третьей перегонки  (дистилляция без дефлегматора)
int PowerTermostat = 1000; // Мощность Термостата.
int TempDeflBegDistil = -800; //Температура в дефлегматоре, для начала подачи воды в холодильник.
int PowerDistil=2000; // Мощность дистилляции
int TempPrev=0;       // Значение предыдущей температуры (для сверки с текущей (проверка стабилизации значение 344 для облегчения отладки)

char StateMachine = 0; // Состояние конечного автомата процесса

char FlUsart = 0; // Признак того, что надо вывести информацию на СОМ-порт
char flNeedAnalyse = 0; // Флаг того, что надо анализировать результат измерения температуры
char flNeedScanKbd = 0; // Флаг того, что надо читать состояние клавиш
char flScanKbd; // Признак того, что в данный момент идет сканирование клавиатуры, состояние не менять.
char CountKeys;       // Переменная для защиты от дребезга
char secPressKeys;    // Признак того, сколько секунд нажата клавиша
unsigned char AddPressKeys = 1;  // Признак того, сколько прибавлять значений, в зависимости от длительности нажатия клавиши.
unsigned char AddPressKeys10 = 10; // Признак того, сколько прибавлять значений, в зависимости от длительности нажатия клавиши.
char CountState = 0;   // Флаг того, что сохраняем состояние процесса (каждое значение - это полсекунды)
char DispDopInfo = 0; // Флаг отображения дополнительной информации (через раз)
// 3 - низкое напряжение для поддержания мощности
// 4 - датчик ds18b20
char flPopr; // Флаг поправки означает что в данный момент редактируется, температура или ШИМ 0-температура, 1- ШИМ.

// Создаем LCD экран
char lcd_buffer[LCD_BUFFER_SIZE]; // предполагаем 2 байта на символ, в международной кодировке
LiquidCrystal_I2C lcd(LCD_I2C_ADDRESS, LCD_WIDTH, LCD_HEIGHT);

float MaxIOut;
float MaxVoltsOut;

char flAllOff;           // Флаг того, что все выключено

unsigned char Counter1 = 0;
long Seconds;   // Текущее состояние времени с начала процесса (не беззнаковое, потому, что есть проверки на <0);
long SecondsEnd;// Время окончания процесса

char NeedDisplaying;
int resultU;

unsigned char StateVolts = 0; // Состояние вычисление среднеквадратичного
//0 - надо вычислить - запускается старт, 1 - вычисляется, 2 - вычислено, 3 - идет обработка рузультата
// 4 - Результат обработан, можно вычислять следующий
int index_input = 0; // Текущий размер массива дла расчета среднеквадратичного
int prev_index_input = 0; // Текущий размер массива дла расчета среднеквадратичного
int indexOut = 0;  // Размер для вывода на экран

unsigned char flCrossZero = 0;
unsigned long TekPower;
unsigned int TimeOpenTriac = 0;
unsigned int TimeOpenTriacFact = 0;
unsigned int TicZero; // Количество тиков таймера от нуля до нуля.

// Установка мощности (Пока в виде переменных)
int Power = 3000;     // Номинальная мощность ТЭНов
int FactPower = 0;     // Мощность ТЭН с учётом потери мощности после триака
int UstPower;     // Нужно получить мощность от регулятора (текущая мощность на всех фазах)
int R_TEN20;        // Сопротиввление ТЭНов, умноженное на 10;
int UstPowerReg = 1000;   // Мощность в режиме регулятора мощности

char flNeedTemp = 0;  // Флаг того, что нужно читать температуру датчиков
char StepOut = 0;     // Признак шага чтения температуры 0 - выдаем команду на запрос температуры
unsigned int BeepTime;
char fl_read; // Признак того, что надо считать средреквадратичное
volatile bool bLCDclearFlag = false;
